﻿//事前にpStyleList.jsx（ドキュメントと同階層）でスタイル名などを設定してから実行してください。

if(app.documents.length != 1 ){
    alert("ドキュメントを1つだけ表示した状態で実行してください");
    exit();
    }
var doc = app.documents[0] ;

//環境設定／単位と増減値
var vpp = doc.viewPreferences ;

//現在の値を保存
var originalRo = vpp.rulerOrigin ;    //定規の単位　開始位置
var originalHmu = vpp.horizontalMeasurementUnits ; //定規の単位　水平方向
var originalVmu = vpp.verticalMeasurementUnits ;  //定規の単位　垂直方向
var originalTmu = vpp.typographicMeasurementUnits ;   //他の単位　組版
var originalTsmu = vpp.textSizeMeasurementUnits ; //他の単位　テキストサイズ
var originalSmu = vpp.strokeMeasurementUnits ;    //他の単位　線

//作業用の値に変更
vpp.rulerOrigin = RulerOrigin.pageOrigin; //定規の単位　開始位置
vpp.horizontalMeasurementUnits = MeasurementUnits.MILLIMETERS;   //定規の単位　水平方向 
vpp.verticalMeasurementUnits = MeasurementUnits.MILLIMETERS;   //定規の単位　垂直方向 
vpp.typographicMeasurementUnits = MeasurementUnits.HA;   //他の単位　組版 
vpp.textSizeMeasurementUnits = MeasurementUnits.Q;   //他の単位　テキストサイズ 
vpp.strokeMeasurementUnits = MeasurementUnits.MILLIMETERS;   //他の単位　線

function asBefore(){
    //環境設定を元に戻す
    vpp.rulerOrigin = originalRo; //定規の単位　開始位置
    vpp.horizontalMeasurementUnits = originalHmu;   //定規の単位　水平方向 
    vpp.verticalMeasurementUnits = originalVmu;   //定規の単位　垂直方向 
    vpp.typographicMeasurementUnits = originalTmu;   //他の単位　組版 
    vpp.textSizeMeasurementUnits = originalTsmu;   //他の単位　テキストサイズ 
    vpp.strokeMeasurementUnits = originalSmu;   //他の単位　線 
}

var myPstyleGroup  ;    // 段落スタイルグループ
var myPstyle ;   //段落スタイル
var myMark ;    //行頭に付加する目印【大見出し】【★】など
var myAdjustValue ;   //調整値
var myPage ;    //ページ
var myPageSerialNum ;   //ページ通し番号
var myPageNum ;    //ページ名（ノンブル（ivxなどもアリ））
var myMarginLeft ;  //左側のマージン
var myColumnCount ;   //コラム数
var myColumnName = 1 ;  //何番目のコラムか（初期値）
var myColumnGuide ;     //コラムガイド位置（配列）
var myColumnGutter ;    //コラム間隔
var myContents ;    //目次文章
var lineLength ; //行数
var fontSize ; //文字サイズ
var tagetCharacter ;    //最終行の先頭文字
var myCenter ;   //最終行1文字目の仮想ボディ中央のy座標var x ; //先頭文字のx座標
var contentsList=new String;
contentsList=( "" );
var newBltAndNum ;  //箇条書き番号

//外部テキストファイルを用意
now = new Date();
myYear = now.getFullYear();
myMonth=now.getMonth()+1;
myDate=now.getDate();
myHours=now.getHours();
myMinutes=now.getMinutes();
mySeconds=now.getSeconds();
nowTime=myYear +"-"+myMonth+"-"+myDate+"-"+myHours+"-"+myMinutes+"-"+mySeconds;
saveFolderPath = app.documents[0].filePath; // ドキュメントの保存フォルダ
fileObj = new File(saveFolderPath +"/目次用"+ nowTime+".txt");
fileObj.encoding="UTF8";

//検索オプションGrep
app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;
app.findChangeGrepOptions.includeHiddenLayers = true;//非表示レイヤーを含めるかどうか
app.findChangeGrepOptions.includeMasterPages = true;//マスターページを含めるかどうか
app.findChangeGrepOptions.includeFootnotes = true;//脚注を含めるかどうか

//ここから関数
function makeContents( mpsg , mps , mmk , mav ){

myPstyleGroup = mpsg ;    //pStyleList.jsxから読み込み
myPstyle = mps ;   //pStyleList.jsxから読み込み
myMark = mmk ;    //pStyleList.jsxから読み込み
//myAdjustValue = mav * 0.25 ;   //pStyleList.jsxから読み込み（歯→mm）
myAdjustValue = mav ;   //pStyleList.jsxから読み込み（mm）
try{

//段落スタイルを指定（グループ名が"-"の場合はグループなしの処理）
if ( myPstyleGroup== "-" ){
    app.findGrepPreferences.appliedParagraphStyle = doc.paragraphStyles.itemByName(myPstyle);
    }else{
        app.findGrepPreferences.appliedParagraphStyle = doc.paragraphStyleGroups.itemByName(myPstyleGroup).paragraphStyles.itemByName(myPstyle);
        }

app.findGrepPreferences.findWhat= "\[\\\S\\\s\~F\]\+" ;//脚注マーカがあっても検索できるように
var gr=doc.findGrep(); // 検索だけ
var grl=gr.length; 

for (i=0; i<grl; i++) { 
    myPage = gr[i].parentTextFrames[0].parentPage ;
    myPageSerialNum = myPage.documentOffset+1 ; //ページ通し番号（1から）
    myPageNum = myPage.name ;
    myColumnGuide = myPage.marginPreferences.columnsPositions ;
    myColumnCount = myPage.marginPreferences.columnCount ;
    myColumnGutter = myPage.marginPreferences.columnGutter ;
    myContents = gr[i].contents ;
    myContents = myContents.replace (/[\u0007\u0003\u200C\u0004]/g,"");	//「ここまでインデント」文字、先頭文字スタイルの終了文字、結合なし、脚注番号マーカを削除
    myContents = myContents.replace (/\t/g, "<<tab>>") ;    //タブを<<tab>>に置換
    myContents = myContents.replace (/\r/g, "") ;   //改行を削除
    myContents = myContents.replace (/\n/g, "<<sr>>") ;     //強制改行を<<sr>>に置換
    newBltAndNum = gr[i].paragraphs[0].bulletsAndNumberingResultText ;    //箇条書き番号・記号
    newBltAndNum = newBltAndNum.replace (/\t/g, "") ;    //箇条書き番号・記号のタブ削除
    myContents = newBltAndNum+">>>>"+myContents ; //箇条書き番号・記号と組み合わせる（>>>>で区切る）
    myContents = myContents.replace (/^>>>>/g, "") ;  //箇条書き番号・記号がない時は>>>>を削除
    //左右ページで使用するマージン（小口／ノド）を切り換え
    if(myPage.side == "lfth"){  //左ページ
        myMarginLeft = myPage.marginPreferences.right ;
        }else{  //右ページおよびシングルページ
            myMarginLeft = myPage.marginPreferences.left ;
            }
    for( j=1 ; j <= myColumnCount ; j++){
        if( gr[ i ].horizontalOffset >= myMarginLeft+myColumnGuide[(j-1)*2] -myColumnGutter&&gr[ i ].horizontalOffset < myMarginLeft+myColumnGuide[j*2-1] ){
            myColumnName = j
            }; //何番目のコラムか（行頭は左側コラム間にはみ出し可）
        }
    //記号の1文字目が※の場合はコラム番号を1に固定
    if ( mmk.search(/^※/) !== -1) {
        myColumnName = "1" ;
        } ;
    //基準位置を最終行に
    lineLength = gr[i].lines.length ; //行数
    tagetCharacter = gr[i].lines[lineLength-1].characters[0] ;    //最終行の先頭文字

    fontSize = tagetCharacter.pointSize ; //文字サイズ
    myCenter = tagetCharacter.baseline - ( fontSize * 0.25 * 0.38 ) ;     //1行目の仮想ボディ中央のy座標
    myCenter = Math.round(myCenter*100)/100 ;    //小数点第三位を四捨五入
    myCenter = myCenter - myAdjustValue ;   //mavで調整
    x = gr[i].characters[0].horizontalOffset ; //先頭文字のx座標
    x = Math.round(x*100)/100 ;    //小数点第三位を四捨五入

    contentsList = contentsList +"\r"+ myMark+myContents +"\t"+myPageNum +"\t"+myPageSerialNum +"\t"+ myColumnName +"\t"+ myCenter + "\t"+ x;
    }
}catch(e){
    alert("pStyleList.jsxの設定に間違いがないか確認してください") ;
    asBefore() ;
    exit();
    }
}
//関数ここまで

//関数を実行
#include "pStyleList.jsx"   

//以下、ソートなど
contentsList = contentsList.replace (/^\r/, "")
//alert(contentsList);

//一旦ファイルに書き込み
flag = fileObj.open("w");
if (flag){
    fileObj.writeln(contentsList);
    fileObj.close();
    };

contentsList2=(""); //整理用のリスト

//配列を作成
var ary = [];
flagA = fileObj.open("r");
if (flagA){
    countA = 0;
    TAB = String.fromCharCode(9);	// タブコード

    while(!fileObj.eof){
        textA = fileObj.readln();	//　１行読み込む
        txtItemA = textA.split(TAB);	//　タブコードで分割
        ary.push(txtItemA);//配列の最後に行を追加
        countA++;
        }
    var  lineNum = countA ;	//行数
    var rowNum = txtItemA.length;	//列数
}

function funcCompare(a, b) {

	if (a[2]*1 < b[2]*1) {return -1}; //ページでソート
	if (a[2]*1 > b[2]*1) {return 1};

	if (a[3]*1 < b[3]*1) {return -1}; //コラムでソート
	if (a[3]*1 > b[3]*1) {return 1};

	if (a[4]*1 < b[4]*1) return -1; //y座標でソート
	if (a[4]*1 > b[4]*1) return 1;    

	if (a[5]*1 < b[5]*1) return -1; //x座標でソート
	if (a[5]*1 > b[5]*1) return 1;    

	return 0;
}
var newAry=ary.sort(funcCompare);   //ソートを実行
var aLength = newAry.length;

for( i=0 ; i<aLength ; i++ ){
var newTxt = newAry[i].join( "\t" );
//newTxt=newTxt.replace (/^([^\t\r]+\t[^\t\r]+)\t.+/g, "$1")  //不要な項目を削除
contentsList2 = contentsList2 + newTxt + "\r" ;
}

//末尾に文章を追加
contentsList2 = contentsList2+"\r///////////////////////\r左より「目次テキスト」「ノンブル」「ページの通し番号」「コラム番号」「y座標（最終行）」「x座標（1行目）」です。" ;
contentsList2 = contentsList2+"\r「ページの通し番号」「コラム番号」「y座標」「x座標」が不要な場合はスクリプトファイルを開き206行目の行頭の//を削除してコメントアウトを解除してください。" ;
contentsList2 = contentsList2+"\r>>>> は箇条書き番号・記号とテキストを区切る記号です" ;
contentsList2 = contentsList2+"\r<<sr>> は強制改行が存在した箇所です" ;
contentsList2 = contentsList2+"\r<<tab>> はタブが存在した箇所です" ;

flagB = fileObj.open("w");
if (flagB){
fileObj.writeln(contentsList2);
fileObj.close();
}

app.changeGrepPreferences = NothingEnum.nothing;
app.findGrepPreferences = NothingEnum.nothing;

//環境設定を元に戻す
asBefore() ;

alert("目次用テキストをドキュメントと同階層に生成しました")
